-------------------------------------------------------------------------------------
-- File Name    : TGT8_plus.VHD
-- Function     : pci_master_model for simulation
-- Editor       : F.O. (ProXi)
-- Date         : 2018/11/15
-- ylz     : ڍׂ  http://www.proxi.co.jp/technolo/pci_bus_test_bench.htm Q
--              : {\[X ASIANL@ (Attributed SIgnAl Naming)  ŋLqĂB
--              :   ڍׂ http://www.proxi.co.jp/technolo/asian.htm Q
-------------------------------------------------------------------------------------
-- yLz{t@C͈ȉ̃\[Xt@CꕔҏŴłB
--  Interface TECH I Vol.3@PCIfoCX݌v iCQoŁj@tCD VHDL\[X
--  ^[Qbg8 (o[Xg]Ή) TGT8.VHD
--  쌠ҁF{qv  
--
--  ҏW҂ɂύXӏ u--px0vtLĂB
--  ȕύX͈ȉB
--  @DIADO@e8_I/OWX^ǉB
--    x[XAhX +4 ԒnFDO[7..0] WR/RD
--    x[XAhX +6 ԒnFDI[7..0] RD ONLY
--  AMf[^̃peB`FbNǉB
--     peBG[ PERR_n '0'ɂB
--     PERR_n ͎M삪I玩NAB
--
-------------------------------------------------------------------------------------
-- library for TGT8.vhd                                                                             --px0
-------------------------------------------------------------------------------------
-- package ǉ邪AώGh~̈וʃt@CɂATGT8_plus.VHD Ɋ܂߂
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
USE ieee.numeric_std.ALL;

package pci_pac is
    -- parity generator
    function even_parity_calculator (
        ad          : std_logic_vector;
        c_be_n      : std_logic_vector
    ) return std_logic;

end pci_pac;

package body pci_pac is
    function even_parity_calculator (
        ad          : std_logic_vector;
        c_be_n      : std_logic_vector
    ) return std_logic is

        variable xc_par : std_logic;

    begin
        xc_par := '0';
        for i in ad'range loop
            xc_par := xc_par xor ad(i);
        end loop;

        for i in c_be_n'range loop
            xc_par := xc_par xor c_be_n(i);
        end loop;
        
        return (xc_par);

    end even_parity_calculator;

end pci_pac;

-------------------------------------------------------------------------------------
-- ȉIWi TGT8_plus.VHD {̕                                                        --px0
-------------------------------------------------------------------------------------
-- TGT8
-------------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

use work.pci_pac.all;                                                                               --px0

entity TGT8 is
    port(
        -- PCIoXMs(^[Qbg8ŎgpM)           --
        PCICLK      : in    std_logic;                      -- PCIoXNbN
        RST_n       : in    std_logic;                      -- 񓯊Zbg
        PCIAD       : inout std_logic_vector(31 downto 0);  -- AhX/f[^oX
        C_BE_n      : in    std_logic_vector(3 downto 0);   -- PCIoXR}h/oCgCl[u
        FRAME_n     : in    std_logic;                      -- t[
        IRDY_n      : in    std_logic;                      -- CjVG[^fB
        DEVSEL_n    : out   std_logic;                      -- foCXZNV
        TRDY_n      : out   std_logic;                      -- ^[QbgfB
        IDSEL       : in    std_logic;                      -- RtBO[VfoCXZNg
        INTA_n      : out   std_logic;                      -- 荞ݏo INTA#
        STOP_n      : out   std_logic;                      -- ]Xgbvv
        PAR         : inout std_logic;                      -- peBrbg
        PERR_n      : out    std_logic;                     -- peBG[                       --px0

        -- PCIoXMs(^[Qbg8ŖgpȐM)           --
        --PERR_n    : out   std_logic;                      -- peBG[                       --px0
        SERR_n      : out   std_logic;                      -- VXeG[
        REQ_n       : out   std_logic;                      -- oXgpvM
        GNT_n       : in    std_logic;                      -- oXgpM
        INTB_n      : out   std_logic;                      -- 荞ݏo INTB#
        INTC_n      : out   std_logic;                      -- 荞ݏo INTC#
        INTD_n      : out   std_logic;                      -- 荞ݏo INTD#
        LOCK_n      : in    std_logic;                      -- rANZX
        SBO_n       : inout std_logic;                      -- Xk[vobNIt
        SDONE_n     : inout std_logic;                      -- Xk[v

        -- [JoXMs
        MEM_ADRS    : out   std_logic_vector(23 downto 2);  -- AhXoX(16MoCg)
        MEM_DATA    : inout std_logic_vector(31 downto 0);  -- f[^oX
        MEM_CEn     : out   std_logic;                      -- SRAM0`3 /CE
        MEM_OEn     : out   std_logic;                      -- SRAM0`3 /OE
        MEM_WE0n    : out   std_logic;                      -- SRAM0 /WE
        MEM_WE1n    : out   std_logic;                      -- SRAM1 /WE
        MEM_WE2n    : out   std_logic;                      -- SRAM2 /WE
        MEM_WE3n    : out   std_logic;                      -- SRAM3 /WE

        -- O荞ݓ̓s
        INT_IN3     : in    std_logic;                      -- 荞ݓ3
        INT_IN2     : in    std_logic;                      -- 荞ݓ2
        INT_IN1     : in    std_logic;                      -- 荞ݓ1
        INT_IN0     : in    std_logic;                      -- 荞ݓ0
                                                            
        -- I/O |[g  di0..7, do0..7                                                               --px0
        sv_do       : out std_logic_vector(7 downto 0);     -- base +4 rd/wr
        av_di       : in  std_logic_vector(7 downto 0);     -- base +6 rd only

        -- for test                                                                                 --px0
        tp0         : out   std_logic;
        tp1         : out   std_logic;
        tp2         : out   std_logic;
        tp3         : out   std_logic;
        tp4         : out   std_logic;
        tp5         : out   std_logic;
        tp6         : out   std_logic;
        tp7         : out   std_logic;
        tp_v0       : out   std_logic_vector(31 downto 0);
        tp_v1       : out   std_logic_vector(3 downto 0); 
        tp_v2       : out   std_logic_vector(31 downto 0);
        tp_v3       : out   std_logic_vector(3 downto 0); 
        cv_cur_state : out  std_logic_vector(2 downto 0)  

    );
end entity TGT8;

architecture RTL of TGT8 is


-- ************************************************************************* --
-- **********    WX^/萔 `
-- ************************************************************************* --

    -- PCIoXR}h/AhX/IDSELz[hWX^ --
    signal PCI_BusCommand           : std_logic_vector(3 downto 0);     -- PCIoXR}hWX^
    signal PCI_Address              : std_logic_vector(31 downto 0);    -- PCIAhXWX^
    signal PCI_IDSEL                : std_logic;                        -- IDSELWX^

    -- [JoXV[PT X^[gtO
    signal LOCAL_Bus_Start  : std_logic;
    -- [JoXV[PT f[^]tO
    signal LOCAL_DTACK              : std_logic;

    -- gCXe[gobt@p̃tbvtbv` --
    -- PCIoXM
    signal PCIAD_HiZ                : std_logic;                        -- AD|[go̓hCu
    signal PCIAD_Port               : std_logic_vector(31 downto 0);    -- AD|[go̓WX^
    signal DEVSEL_HiZ, DEVSEL_Port  : std_logic;                        -- DEVSEL#o̓hCu/o̓WX^
    signal TRDY_HiZ, TRDY_Port      : std_logic;                        -- TRDY#o̓hCu/o̓WX^
    signal INTA_HiZ, INTA_Port      : std_logic;                        -- INTA#o̓hCu/o̓WX^
    signal PAR_HiZ,  PAR_Port       : std_logic;                        -- PARo̓hCu/o̓WX^
    signal STOP_HiZ, STOP_Port      : std_logic;                        -- STOPo̓hCu/o̓WX^

    signal PERR_HiZ, PERR_Port      : std_logic;                        -- _~[m[h(^[Qbg8gp)
    signal SERR_HiZ, SERR_Port      : std_logic;
    signal REQ_HiZ,  REQ_Port       : std_logic;
    signal INTB_HiZ, INTB_Port      : std_logic;
    signal INTC_HiZ, INTC_Port      : std_logic;
    signal INTD_HiZ, INTD_Port      : std_logic;
    signal SBO_HiZ,  SBO_Port       : std_logic;
    signal SDONE_HiZ,SDONE_Port     : std_logic;

    --  PCIoXR}h(rbgp^[`) --
    -- RtBM[VTCN
    constant PCI_CfgCycle           : std_logic_vector(3 downto 1)  := ("101");
    constant PCI_CfgReadCycle       : std_logic_vector(3 downto 0)  := ("1010");
    constant PCI_CfgWriteCycle      : std_logic_vector(3 downto 0)  := ("1011");
    -- TCN
    constant PCI_MemCycle           : std_logic_vector(3 downto 1)  := ("011");
    constant PCI_MemReadCycle       : std_logic_vector(3 downto 0)  := ("0110");
    constant PCI_MemWriteCycle      : std_logic_vector(3 downto 0)  := ("0111");
    -- I/OTCN
    constant PCI_IoCycle            : std_logic_vector(3 downto 1)  := ("001");
    constant PCI_IoReadCycle        : std_logic_vector(3 downto 0)  := ("0010");
    constant PCI_IoWriteCycle       : std_logic_vector(3 downto 0)  := ("0011");

    -- RtBM[VWX^Q(ǂݏopWX^) --
    constant CFG_VendorID           : std_logic_vector(15 downto 0) := (X"4949");   -- x_ID 4949h
    constant CFG_DeviceID           : std_logic_vector(15 downto 0) := (X"7777");   -- foCXID 7777h
    constant CFG_Command            : std_logic_vector(15 downto 0) := (X"0000");
    constant CFG_Status             : std_logic_vector(15 downto 0) := (X"0200");   -- DEVSEL# 
    constant CFG_BaseClass          : std_logic_vector(7  downto 0) := (X"05");     -- 05h RAM
    constant CFG_SubClass           : std_logic_vector(7  downto 0) := (X"00");
    constant CFG_ProgramIF          : std_logic_vector(7  downto 0) := (X"00");
    constant CFG_RevisionID         : std_logic_vector(7  downto 0) := (X"01");     -- rW 1
    constant CFG_HeaderType         : std_logic_vector(7  downto 0) := (X"00");     -- wb_^Cv0
    constant CFG_Int_Pin            : std_logic_vector(7  downto 0) := (X"01");     -- INTA#̂ݎgp

    -- RtBM[VWX^Q(ǂݏWX^) --
    -- R}hWX^ Cl[urbg
    signal CFG_Cmd_Mem              : std_logic;
    -- R}hWX^ I/OCl[urbg
    signal CFG_Cmd_Io               : std_logic;
    -- x[XAhXWX^()
    signal CFG_Base_Addr0           : std_logic_vector(31 downto 24);

    -- x[XAhXWX^(I/O)
    --signal CFG_Base_Addr1         : std_logic_vector(15 downto 2);                                --px0
    signal CFG_Base_Addr1           : std_logic_vector(15 downto 3);                                --px0

    -- C^vgCWX^
    signal CFG_Int_Line : std_logic_vector(7 downto 0);

    -- AhXfR[htO
    signal Hit_Device               : std_logic;                        -- foCXqbg
    signal Hit_Memory               : std_logic;                        -- TCNqbg
    signal Hit_Io                   : std_logic;                        -- I/OTCNqbg
    signal Hit_Config               : std_logic;                        -- RtBO[VTCNqbg

    -- [JoX gCXe[g
    signal MEM_DATA_HiZ             : std_logic;                        -- f[^oXgCXe[g
    signal MEM_DATA_Port            : std_logic_vector(31 downto 0);    -- f[^oX

    --  荞ݐ䃌WX^Q
    -- C^vgXe[^X/tOWX^
    signal INT_STAT3                : std_logic;
    signal INT_STAT2                : std_logic;
    signal INT_STAT1                : std_logic;
    signal INT_STAT0                : std_logic;
    -- C^vg}XN()WX^
    signal INT_MSK3                 : std_logic;
    signal INT_MSK2                 : std_logic;
    signal INT_MSK1                 : std_logic;
    signal INT_MSK0                 : std_logic;

    -- ׂ̈̒ǉM                                                                         --px0
    signal xmv_di_q                 : std_logic_vector(7 downto 0);
    signal xsv_di_q0                : std_logic_vector(7 downto 0);
    signal xsv_do                   : std_logic_vector(7 downto 0);

    signal xs_PAR_Port_q            : std_logic;
    signal xc_adr_par               : std_logic;
    signal xc_data_par              : std_logic;

    signal xsv_adr                  : std_logic_vector(31 downto 0);
    signal xsv_data                 : std_logic_vector(31 downto 0);
    signal xsv_command              : std_logic_vector(3 downto 0);
    signal xsv_be_n                 : std_logic_vector(3 downto 0);

    signal xs_frame                 : std_logic;
    signal xs_frame_q               : std_logic;
    signal xsp_frame_on             : std_logic;
    signal xsp_frame_on_q           : std_logic;
    signal xs_trdy                  : std_logic;
    signal xs_trdy_q                : std_logic;

begin


-- ************************************************************************* --
-- **********    
-- ************************************************************************* --
    -- gCXe[gobt@
    MEM_DATA    <= (others => 'Z') when MEM_DATA_HiZ = '1' else MEM_DATA_Port;
    PCIAD       <= (others => 'Z') when PCIAD_HiZ = '1'    else PCIAD_Port;
    DEVSEL_n    <= 'Z'    when DEVSEL_HiZ = '1' else DEVSEL_Port;
    TRDY_n      <= 'Z'    when TRDY_HiZ = '1'   else TRDY_Port;
    INTA_n      <= 'Z'    when INTA_HiZ = '1'   else INTA_Port;
    ---PAR      <= 'Z'    when PAR_HiZ = '1'    else PAR_Port;                                      --px0
    PAR         <= 'Z'    when PAR_HiZ = '1'    else xs_PAR_Port_q;                                 --px0
    STOP_n      <= 'Z'    when STOP_HiZ = '1'   else STOP_Port;

    PERR_n      <= 'Z'    when PERR_HiZ = '1'   else PERR_Port;                                     --px0

    -- gps̏Ԑݒ(nCCs[_XԂɌŒ)
    SERR_n      <= 'Z'    when SERR_HiZ = '1'   else    SERR_Port;  SERR_HiZ    <= '1'; SERR_Port   <= '0';
    REQ_n       <= 'Z'    when REQ_HiZ = '1'    else    REQ_Port;   REQ_HiZ     <= '1'; REQ_Port    <= '0';
    INTB_n      <= 'Z'    when INTB_HiZ = '1'   else    INTB_Port;  INTB_HiZ    <= '1'; INTB_Port   <= '0';
    INTC_n      <= 'Z'    when INTC_HiZ = '1'   else    INTC_Port;  INTC_HiZ    <= '1'; INTC_Port   <= '0';
    INTD_n      <= 'Z'    when INTD_HiZ = '1'   else    INTD_Port;  INTD_HiZ    <= '1'; INTD_Port   <= '0';
    SBO_n       <= 'Z'    when SBO_HiZ = '1'    else    SBO_Port;   SBO_HiZ     <= '1'; SBO_Port    <= '0';
    SDONE_n     <= 'Z'    when SDONE_HiZ = '1'  else    SDONE_Port; SDONE_HiZ   <= '1'; SDONE_Port  <= '0';


    ----------------------------------------------
    -- DO                                                                                           --px0
    sv_do <= xsv_do;

    -- DI synchronizer                                                                              --px0
    process (RST_n, PCICLK) begin
        if (RST_n = '0') then
            xmv_di_q    <= (others => '0');
            xsv_di_q0   <= (others => '0');
        elsif (PCICLK'event and PCICLK = '1') then
            xmv_di_q    <= av_di;
            xsv_di_q0   <= xmv_di_q;
        end if;
    end process;

    -- for test                                                                                     --px0
    tp0     <= Hit_Config;
    tp1     <= Hit_Io;
    tp2     <= xc_adr_par;
    tp3     <= xc_data_par;
    tp4     <= PAR_HiZ;
    tp5     <= PAR_Port;
    tp6     <= xs_PAR_Port_q;
    tp7     <= 'Z';
    tp_v0   <= xsv_adr;
    tp_v1   <= xsv_command;
    tp_v2   <= xsv_data;
    tp_v3   <= xsv_be_n;


    ----------------------------------------------
    -- address, data latch                                                                          --px0
    ----------------------------------------------
    xs_frame        <= not FRAME_n;
    xsp_frame_on    <= xs_frame and (not xs_frame_q);
    xs_trdy         <= not TRDY_Port;

    adr_data_latch : process( PCICLK, RST_n ) begin
        if ( RST_n = '0' ) then    
            xs_frame_q      <= '0';
            xsp_frame_on_q  <= '0';
            xs_trdy_q       <= '0';
            xsv_adr         <= (others => '0');
            xsv_command     <= (others => '0');
            xsv_data        <= (others => '0');
            xsv_be_n        <= (others => '0');

        elsif (PCICLK'event and PCICLK = '1') then
            xs_frame_q      <= xs_frame;
            xsp_frame_on_q  <= xsp_frame_on;
            xs_trdy_q       <= xs_trdy;

            if (xsp_frame_on = '1') then
                xsv_adr     <= PCIAD;
                xsv_command <= C_BE_n;
            end if;

            if (xs_trdy = '1') then
                xsv_data    <= PCIAD;
                xsv_be_n    <= C_BE_n;
            end if;
        end if;
    end process;

    xc_adr_par <= even_parity_calculator (xsv_adr, xsv_command);
    xc_data_par <= even_parity_calculator (xsv_data, xsv_be_n);


    ----------------------------------------------
    -- parity checker                                                                               --px0
    ----------------------------------------------
    parity_checker0 : process( PCICLK, RST_n ) begin
        if (RST_n = '0') then    
            PERR_Port   <= '1';
            PERR_HiZ    <= '1';

        elsif (PCICLK'event and PCICLK = '1') then
            if (xsp_frame_on_q = '1') then
                if (xc_adr_par /= PAR) then
                    PERR_Port   <= '0';
                    PERR_HiZ    <= '0';
                else
                    PERR_Port   <= '1';
                    PERR_HiZ    <= '1';
                end if;
            end if;

            if (xs_trdy_q = '1') then
                if (xc_data_par /= PAR) then
                    PERR_Port   <= '0';
                    PERR_HiZ    <= '0';
                else
                    PERR_Port   <= '1';
                    PERR_HiZ    <= '1';
                end if;
            end if;
        end if;
    end process;

    ----------------------------------------------


-- ************************************************************************* --
-- **********    PCI^[QbgV[PT
-- ************************************************************************* --

PCI_TGT_Seq : process( PCICLK, RST_n )

    -- PCI^[QbgV[PT Xe[go[WX^ --
    variable PCI_CURRENT_STATE  : std_logic_vector (2 downto 0);    -- ݂̃Xe[g
    variable PCI_NEXT_STATE     : std_logic_vector (2 downto 0);    -- ̃Xe[g

    -- PCI^[QbgV[PT Xe[g}V`
    constant BUS_IDLE           : std_logic_vector (2 downto 0) :="000";
    constant ADRS_COMPARE       : std_logic_vector (2 downto 0) :="001";
    constant BUS_BUSY           : std_logic_vector (2 downto 0) :="010";
    constant WAIT_IRDY          : std_logic_vector (2 downto 0) :="011";
    constant WAIT_LOCAL_ACK     : std_logic_vector (2 downto 0) :="100";
    constant ACC_COMPLETE       : std_logic_vector (2 downto 0) :="101";
    constant DIS_CONNECT        : std_logic_vector (2 downto 0) :="110";
    constant TURN_AROUND        : std_logic_vector (2 downto 0) :="111";

    -- o[Xg]AhXJE^
    variable Adrs_Pointer       : unsigned(23 downto 2);
    -- o[Xg]AhXtO
    variable Point_LAST_ADRS    : boolean;

begin
    -- ********** o[Xg]AhX ********** --
    if (RST_n = '0') then    -- PCIoXZbg(񓯊Zbg)
        Point_LAST_ADRS     := FALSE;
    else
        -- o[Xg]AhXŏʂĂ
        if (Adrs_Pointer = "1111111111111111111111") then
            Point_LAST_ADRS := TRUE;
        else
            Point_LAST_ADRS := FALSE;
        end if;
    end if;


    -- ********** Zbg ********** --
    if (RST_n = '0') then                               -- PCIoXZbg(񓯊Zbg)
        PCI_CURRENT_STATE   := BUS_IDLE;                -- Xe[g}V IDLE Zbg
        PCI_NEXT_STATE      := BUS_IDLE;                -- Xe[g}V IDLE Zbg

        LOCAL_Bus_Start     <= '0';                     -- [JoXV[PT X^[gtO NA

        PCI_BusCommand <= (others => '0');              -- PCIoXR}hWX^ NA
        PCI_Address         <= (others => '0');         -- PCIoXAhXWX^ NA
        PCI_IDSEL           <= '0';                     -- IDSELWX^ NA
        Adrs_Pointer        := ( others => '0' );       -- o[Xg]AhXJE^ NA

        -- o͒[qnCCs[_X
        PCIAD_HiZ           <= '1';
        DEVSEL_HiZ          <= '1'; DEVSEL_Port <= '1'; -- DEVSEL#="H"
        TRDY_HiZ            <= '1'; TRDY_Port   <= '1'; -- TRDY#="H"
        STOP_HiZ            <= '1'; STOP_Port   <= '1'; -- STOP#="H"
        PAR_HiZ             <= '1';                     -- PAR_Port̓peBWFl[^Ő

        xs_PAR_Port_q       <= '0';                                                                 --px0

    -- ********** PCI^[QbgV[PT Xe[g}V ********** --
    elsif (PCICLK'event and PCICLK = '1') then
        PCI_CURRENT_STATE   := PCI_NEXT_STATE;          -- Xe[g}V

        xs_PAR_Port_q       <= PAR_Port;                                                            --px0

        case PCI_CURRENT_STATE is
            -- ********** BUS_IDLE̓ ********** --
            when BUS_IDLE =>        -- gUNV̊Jn҂
                if (FRAME_n = '0' and IRDY_n = '1') then    -- gUNVJn
                    PCI_BusCommand  <= C_BE_n;              -- PCIoXR}h擾
                    PCI_Address     <= PCIAD;               -- AhX擾
                    PCI_IDSEL       <= IDSEL;               -- IDSEL擾
                    Adrs_Pointer    := unsigned(PCIAD(23 downto 2));
                    PCI_NEXT_STATE  := ADRS_COMPARE;

                else                                        -- oXACh̃Xe[gɂƂǂ܂
                    PCI_NEXT_STATE  := BUS_IDLE;
                end if;

            -- ********** ADRS_COMPARE̓ ********** --
            when ADRS_COMPARE =>    -- AhXfR[hʂ𒲂ׂ
                if (Hit_Device = '1') then                      -- Iꂽ
                    DEVSEL_Port     <= '0'; DEVSEL_HiZ <= '0';  -- DEVLSEL#AT[g
                    TRDY_HiZ        <= '0';                     -- TRDY#  "H"ɃhCu
                    STOP_HiZ        <= '0';                     -- STOP#  "H"ɃhCu
                    PCI_NEXT_STATE  := WAIT_IRDY;               -- CjVG[^fB҂Xe[g
                    
                else    -- IĂȂ
                    PCI_NEXT_STATE := BUS_BUSY;    -- gUNV̏I҂Xe[g
                end if;

            -- ********** BUS_BUSY̓ ********** --
            when BUS_BUSY =>        -- gUNVI҂
                if (FRAME_n = '1' and IRDY_n = '1') then    -- gUNVI(ACh)
                    PCI_NEXT_STATE := BUS_IDLE;             -- gUNVJn҂Xe[g

                else    -- gUNVȂ炱̃Xe[gɂƂǂ܂
                    PCI_NEXT_STATE := BUS_BUSY;
                end if;

            -- ********** WAIT_IRDY̓ ********** --
            when WAIT_IRDY =>       -- CjVG[^fB҂
                if (IRDY_n = '0') then                      -- CjVG[^̏
                    if (PCI_BusCommand(0) = '0') then       -- [hTCN̂Ƃ
                        PCIAD_HiZ   <= '0';                 -- PCIAD[31:0]oXhCu
                    end if;
                    LOCAL_Bus_Start <= '1';                 -- [JoXV[PT X^[g!
                    PCI_NEXT_STATE := WAIT_LOCAL_ACK;       -- [JoXV[PTI҂Xe[g

                else                -- CjVG[^̏܂Ȃ炱̃Xe[gɂƂǂ܂
                    PCI_NEXT_STATE := WAIT_IRDY;
                end if;

            -- ********** WAIT_LOCAL_ACK̓ ********** --
            when WAIT_LOCAL_ACK =>  -- [JoXV[PTI҂
                LOCAL_Bus_Start     <= '0';                 -- [JoXV[PT X^[gtO NA

                if (LOCAL_DTACK = '1') then                 -- [JoXV[PT f[^]
                    TRDY_Port       <= '0';                 -- TRDY# AT[g
                    PCI_NEXT_STATE  := ACC_COMPLETE;        -- ANZXXe[g

                else                                        -- [JoXV[PT̏܂Ȃ炱̃Xe[gɂƂǂ܂
                    PCI_NEXT_STATE  := WAIT_LOCAL_ACK;
                end if;

            -- ********** ACC_COMPLETE̓ ********** --
            when ACC_COMPLETE =>    -- ANZXXe[g
                TRDY_Port           <= '1';                 -- TRDY# fBAT[g
                PCIAD_HiZ           <= '1';                 -- PCIAD[31:0]oXhCu
                if (PCI_BusCommand(0) = '0') then           -- [hTCNł
                    PAR_HiZ         <= '0' ;                -- PAR hCuJn
                end if;

                if (FRAME_n = '0') then                     -- FRAME# = 'L'Ȃo[Xg]v
                    if ( Hit_Memory = '1' and PCI_Address(1 downto 0) = "00"
                        and Point_LAST_ADRS = FALSE) then
                                                            -- &AhXCNg[h=jAo[Xg
                                                            -- AhXŏIAhXł͂Ȃ
                        Adrs_Pointer                := Adrs_Pointer + 1 ;       -- AhXCNg
                        PCI_Address(23 downto 2)    <= std_logic_vector(Adrs_Pointer);
                        PCI_NEXT_STATE              := WAIT_IRDY;               -- CjVG[^fB҂Xe[g

                    else
                        STOP_Port                   <= '0';                     -- STOP# AT[g
                        PCI_NEXT_STATE              := DIS_CONNECT;             -- fBXRlNgXe[g
                    end if;

                else                                            -- Pf[^tF[ỸgUNV̎
                    DEVSEL_Port         <= '1';                 -- DEVSEL#fBAT[g
                    PCI_NEXT_STATE      := TURN_AROUND;         --  ^[AEhXe[g
                end if;

            -- ********** DIS_CONNECT̓ ********** --
            when DIS_CONNECT =>        -- fBXRlNg
                if (FRAME_n = '1') then                         -- CjVG[^STOP#F
                    DEVSEL_Port         <= '1';                 -- DEVSEL# fBAT[g
                    STOP_Port           <= '1';                 -- STOP# fBAT[g
                    PCI_NEXT_STATE      := TURN_AROUND;         -- TURN_AROUNDXe[g

                else                                            -- CjVG[^STOP#FĂȂ΂̃Xe[gɂƂǂ܂
                    PCI_NEXT_STATE      := DIS_CONNECT;
                end if;

            -- ********** TURN_AROUND̓ ********** --
            when TURN_AROUND =>        -- ^[AEhXe[g

                DEVSEL_HiZ          <= '1';                 -- DEVSEL#hCu
                TRDY_HiZ            <= '1';                 -- TRDY#hCu
                STOP_HiZ            <= '1';                 -- STOP#hCu
                PAR_HiZ             <= '1';                 -- PARhCu
                PCI_NEXT_STATE      := BUS_IDLE;            -- gUNVJn҂Xe[g

            -- ****************************************** --
            when others => null;    -- ȊO̒lł͉ȂꍇłK

        end case;

        cv_cur_state    <= PCI_CURRENT_STATE;               -- for test                             --px0

    end if;

end process PCI_TGT_Seq;


-- ************************************************************************* --
-- **********    [JoXV[PT
-- ************************************************************************* --

-- [JAhXoXփAhXo
MEM_ADRS(23 downto 2) <= PCI_Address(23 downto 2);


LOCAL_BUS_Seq : process( PCICLK, RST_n )
    -- [JoXV[PT Xe[go[WX^ --
    variable LOCAL_CURRENT_STATE    : std_logic_vector (2 downto 0);    -- ݂̃Xe[g
    variable LOCAL_NEXT_STATE       : std_logic_vector (2 downto 0);    -- ̃Xe[g

    -- [JoXV[PT Xe[g}V`
    constant LOCAL_IDLE             : std_logic_vector(2 downto 0) := "000";
    constant LOCAL_MEM_ACCESS       : std_logic_vector(2 downto 0) := "001";
    constant LOCAL_IO_ACCESS        : std_logic_vector(2 downto 0) := "010";
    constant LOCAL_CFG_ACCESS       : std_logic_vector(2 downto 0) := "011";
    constant LOCAL_STATE_COMP       : std_logic_vector(2 downto 0) := "100";

    -- ANZX EFCgJE^
    variable WAIT_Count             : unsigned(3 downto 0);

    -- 荞ݓ͏ԕۑtO
    variable INT_IN3_flg            : std_logic;
    variable INT_IN2_flg            : std_logic;
    variable INT_IN1_flg            : std_logic;
    variable INT_IN0_flg            : std_logic;

begin
    -- ********** Zbg ********** --
    if ( RST_n = '0' ) then    -- PCIoXZbgAT[gꂽƂ
        -- Xe[go[WX^NA
        LOCAL_CURRENT_STATE := (others => '0');    -- [JoXV[PT Zbg
        LOCAL_NEXT_STATE    := (others => '0');    -- [JoXV[PT Zbg

        -- RtBO[VWX^ [h/CgWX^ C^vgC NA
        CFG_Cmd_Mem         <= '0';
        CFG_Cmd_Io          <= '0';
        CFG_Base_Addr0      <= (others => '0');
        CFG_Base_Addr1      <= (others => '0');
        CFG_Int_Line        <= (others => '0');

        -- [JoXfBZ[u
        MEM_CEn             <= '1';                 -- SRAM0`3 /CE
        MEM_OEn             <= '1';                 -- SRAM0`3 /OE
        MEM_WE0n            <= '1';                 -- SRAM0 /WE
        MEM_WE1n            <= '1';                 -- SRAM1 /WE
        MEM_WE2n            <= '1';                 -- SRAM2 /WE
        MEM_WE3n            <= '1';                 -- SRAM3 /WE
        ----MEM_DATA_HiZ    <= '0';                 -- f[^oXo͕                           --px0
        MEM_DATA_HiZ        <= '1';                 -- [Jf[^oX͕                   --px0

        PCIAD_Port          <= (others => '0');     -- ADo̓WX^ NA
        MEM_DATA_Port       <= (others => '0');     -- MEM_DATAo̓WX^ NA

        -- ANZX EFCgJE^ NA
        WAIT_Count          := (others => '0');

        -- [JoXV[PT f[^]tO NA
        LOCAL_DTACK         <= '0';

        -- 荞ݐ䃌WX^ --
        INT_MSK3            <= '0';                 -- 荞݃}XNWX^ NA
        INT_MSK2            <= '0';
        INT_MSK1            <= '0';
        INT_MSK0            <= '0';
        INT_STAT3           <= '0';                 -- 荞ݗvWX^ NA
        INT_STAT2           <= '0';
        INT_STAT1           <= '0';
        INT_STAT0           <= '0';
        INT_IN3_flg         := '0';                 -- 荞ݓ̓tO NA
        INT_IN2_flg         := '0';
        INT_IN1_flg         := '0';
        INT_IN0_flg         := '0';
        INTA_HiZ            <='1';                  -- INTA# nCCs[_X
        INTA_Port           <= '0';

        xsv_do <= (others => '0');                                                                  --px0

    elsif (PCICLK'event and PCICLK = '1') then
        -- **********    荞݃Rg[     ********** --
        if (INT_IN3 = '0' and INT_IN3_flg = '1') then   -- O荞ݓ3 "L"
            INT_STAT3   <= '1';                         -- 荞݃Xe[^XWX^3
        end if;
        if (INT_IN2 = '0' and INT_IN2_flg = '1') then   -- O荞ݓ2 "L"
            INT_STAT2   <= '1';                         -- 荞݃Xe[^XWX^2
        end if;

        if (INT_IN1 = '0' and INT_IN1_flg = '1') then   -- O荞ݓ1 "L"
            INT_STAT1   <= '1';                         -- 荞݃Xe[^XWX^1
        end if;
        if (INT_IN0 = '0' and INT_IN0_flg = '1') then   -- O荞ݓ0 "L"
            INT_STAT0   <= '1';                         -- 荞݃Xe[^XWX^0
        end if;

        if (
            (INT_STAT3 = '1' and INT_MSK3 = '1')        -- `l3荞ݔ&荞݉
            or
            (INT_STAT2 = '1' and INT_MSK2 = '1')        -- `l2荞ݔ&荞݉
            or
            (INT_STAT1 = '1' and INT_MSK1 = '1')        -- `l1荞ݔ&荞݉
            or
            (INT_STAT0 = '1' and INT_MSK0 = '1')        -- `l0荞ݔ&荞݉
        ) then
            INTA_HiZ    <= '0';                         -- INTA#hCuJn(AT[g)
        else
            INTA_HiZ    <= '1';                         -- nCCs[_X
        end if;

        INT_IN3_flg     := INT_IN3;                     -- ݂̊荞ݓ͏Ԃ̕ۑ
        INT_IN2_flg     := INT_IN2;
        INT_IN1_flg     := INT_IN1;
        INT_IN0_flg     := INT_IN0;

        -- ********** [JoXV[PT Xe[g}V ********** --
        LOCAL_CURRENT_STATE := LOCAL_NEXT_STATE;

        case LOCAL_CURRENT_STATE is
            -- ********** LOCAL_IDLE̓ ********** --
            when LOCAL_IDLE =>                                      -- [JoXV[PT X^[gw҂
                if (LOCAL_Bus_Start = '1' ) then                    -- [JoXV[PT X^[g!
                    if (Hit_Config = '1') then                      -- RtBO[VTCNqbg
                        LOCAL_NEXT_STATE    := LOCAL_CFG_ACCESS;    -- RtBO[VXe[g
                    end if;

                    if (Hit_Memory = '1') then                      -- TCNqbg
                        LOCAL_NEXT_STATE    := LOCAL_MEM_ACCESS;    -- ANZXXe[g
                    end if;

                    if (Hit_Io = '1') then                          -- I/OTCNqbg
                        LOCAL_NEXT_STATE    := LOCAL_IO_ACCESS;     -- I/OANZXXe[g
                    end if;

                else                                                -- [JoXV[PT X^[gtO܂Ȃ炱̃Xe[gɂƂǂ܂
                    LOCAL_NEXT_STATE        := LOCAL_IDLE;

                end if;

            -- ********** LOCAL_MEM_ACCESS̓ ********** --
            when LOCAL_MEM_ACCESS =>
                case WAIT_Count is
                    when X"0" =>    -- EFCgJE^0NbN
                        MEM_CEn <= '0';                         -- SRAM /CE AT[g
                        if (PCI_BusCommand(0) = '1') then       -- CgTCN
                            MEM_DATA_Port(31 downto 0) <= PCIAD(31 downto 0); -- Cgf[^
                            MEM_DATA_HiZ    <= '0';             -- [Jf[^oXo͕       --px0
                        else                                    -- [hTCN
                            MEM_DATA_HiZ    <= '1';             -- [Jf[^oX͕
                        end if;

                        LOCAL_NEXT_STATE    := LOCAL_MEM_ACCESS ;  -- ANZX͂܂IȂ

                    when X"1" =>    -- EFCgJE^1NbN
                        if (PCI_BusCommand(0) = '1') then       -- CgTCN
                            MEM_WE3n        <= C_BE_n(3);       -- oCgCl[u/WEɏo
                            MEM_WE2n        <= C_BE_n(2);
                            MEM_WE1n        <= C_BE_n(1);
                            MEM_WE0n        <= C_BE_n(0);
                            MEM_DATA_HiZ    <= '0';             -- [Jf[^oXo͕       --px0
                        else                                    -- [hTCN
                            MEM_OEn <= '0';                     -- SRAM /OE AT[g
                            MEM_DATA_HiZ <= '1';                -- [Jf[^oX͕       --px0
                        end if;

                        LOCAL_NEXT_STATE := LOCAL_MEM_ACCESS ;  -- ANZX͂܂IȂ

                    when X"4" =>    -- EFCgJE^4NbN
                        if (PCI_BusCommand(0) = '1') then       -- CgTCN
                            MEM_WE3n        <= '1';             -- SRAM /WE fBZ[u
                            MEM_WE2n        <= '1';
                            MEM_WE1n        <= '1';
                            MEM_WE0n        <= '1';
                            MEM_DATA_HiZ    <= '0';             -- [Jf[^oXo͕       --px0
                         else                                   -- [hTCN
                            PCIAD_Port(31 downto 0) <= MEM_DATA;-- SRAMf[^ADoXɏo
                            MEM_OEn         <= '1';             -- SRAM /OE fBAT[g
                            MEM_DATA_HiZ    <= '1';             -- [Jf[^oX͕       --px0
                         end if;
                            
                         LOCAL_DTACK        <= '1' ;            -- [JoXV[PT f[^]tO Zbg
                         LOCAL_NEXT_STATE   := LOCAL_STATE_COMP;-- ANZX

                    when others =>    -- ̂܂܂̏ԂŃEFCgԂo߂̂҂
                        LOCAL_NEXT_STATE    := LOCAL_MEM_ACCESS ;   -- ANZX͂܂IȂ

                end case;

                WAIT_Count := WAIT_Count + 1;                   -- EFCgJEg+1

            -- ********** LOCAL_IO_ACCESS̓ ********** --
            when LOCAL_IO_ACCESS =>
                if (PCI_BusCommand(0) = '1') then               -- CgTCN
                    case PCI_Address(2 downto 0) is             -- 荞݃Xe[^XWX^ւ̃ANZX   --px0
                        when "000" =>                                                                       --px0
                            if (PCIAD(3) = '1') then            -- 荞݃`l3
                                INT_STAT3   <= '0';             -- Xe[^XNA
                            end if ;

                            if (PCIAD(2) = '1') then            -- 荞݃`l2
                                INT_STAT2   <= '0';             -- Xe[^XNA
                            end if ;

                            if (PCIAD(1) = '1') then            -- 荞݃`l1
                                INT_STAT1   <= '0';             -- Xe[^XNA
                            end if ;

                            if (PCIAD(0) = '1') then            -- 荞݃`l0
                                INT_STAT0   <= '0';             -- Xe[^XNA
                            end if ;

                        when "010" =>                           -- 荞݃}XNWX^ւ̃ANZX       --px0
                            INT_MSK3    <= PCIAD(19);           -- 荞݃}XN #3
                            INT_MSK2    <= PCIAD(18);           -- 荞݃}XN #2
                            INT_MSK1    <= PCIAD(17);           -- 荞݃}XN #1
                            INT_MSK0    <= PCIAD(16);           -- 荞݃}XN #0

                        when "100" =>                           -- do|[gւ̃ANZX                     --px0
                             xsv_do     <= PCIAD(7 downto 0);   -- DO0..7

                        when others => null;    -- ȊÕANZX͖
                    end case;

                else    -- [hTCN
                    case PCI_Address(2 downto 0) is             -- 荞݃Xe[^XWX^ւ̃ANZX   --px0
                        when "000" =>                                                                       --px0
                            PCIAD_Port(31 downto  4) <= (others => '0');
                            PCIAD_Port(3)  <= INT_STAT3;        -- 荞3Xe[^X
                            PCIAD_Port(2)  <= INT_STAT2;        -- 荞2Xe[^X
                            PCIAD_Port(1)  <= INT_STAT1;        -- 荞1Xe[^X
                            PCIAD_Port(0)  <= INT_STAT0;        -- 荞0Xe[^X

                        when "010" =>                           -- 荞݃}XNWX^ւ̃ANZX       --px0
                            PCIAD_Port(31 downto 20) <= (others => '0');
                            PCIAD_Port(19) <= INT_MSK3;         -- 荞3}XN
                            PCIAD_Port(18) <= INT_MSK2;         -- 荞2}XN
                            PCIAD_Port(17) <= INT_MSK1;         -- 荞1}XN
                            PCIAD_Port(16) <= INT_MSK0;         -- 荞0}XN
                            PCIAD_Port(15 downto  4) <= (others => '0');

                        when "100" =>                           -- do|[gǂݕԂ                         --px0
                            PCIAD_Port(7 downto 0)      <= xsv_do;
                            PCIAD_Port(31 downto 8)     <= (others => '0');

                        when "110" =>                           -- di|[gread                             --px0
                            PCIAD_Port(7 downto 0)      <= xsv_di_q0;
                            PCIAD_Port(31 downto 8)     <= (others => '0');

                        when others =>                          -- ȊÕANZX0Ԃ
                            PCIAD_Port(31 downto 0)     <= (others => '0');
                    end case;

                end if;

                LOCAL_DTACK         <= '1';
                LOCAL_NEXT_STATE    := LOCAL_STATE_COMP;

            -- ********** LOCAL_CFG_ACCESS̓ ********** --
            when LOCAL_CFG_ACCESS =>                            -- RtBO[VTCN
                if (PCI_BusCommand(0) = '1' ) then              -- RtBO[VCgTCN
                    case PCI_Address(7 downto 2) is
                        when "000001" =>                        -- R}hWX^ Cl[u
                            if (C_BE_n(0) = '0') then
                                CFG_Cmd_Mem     <= PCIAD(1);
                                CFG_Cmd_Io      <= PCIAD(0);
                            end if;

                        when "000100" =>                        -- x[XAhXWX^0
                            if (C_BE_n(3) = '0') then
                                CFG_Base_Addr0(31 downto 24) <= PCIAD(31 downto 24);
                            end if;

                        when "000101" =>                        -- x[XAhXWX^1
                            if (C_BE_n(1) = '0') then
                                CFG_Base_Addr1(15 downto  8) <= PCIAD(15 downto  8);
                            end if;

                            if (C_BE_n(0) = '0') then
                                --CFG_Base_Addr1( 7 downto  2)  <= PCIAD( 7 downto  2);             --px0
                                CFG_Base_Addr1( 7 downto  3)    <= PCIAD( 7 downto  3);             --px0
                            end if;

                        when "001111" =>                        -- 荞݃CWX^
                            if (C_BE_n(0) = '0') then
                                CFG_Int_Line(7 downto 0) <= PCIAD(7 downto 0);
                            end if;
                        when others => null;                    -- ȊO̒lł͉ȂꍇłK
                    end case;

                else                                            -- RtBO[V[hTCN
                    case PCI_Address(7 downto 2) is
                        when "000000" =>                        -- x_ID/foCXID
                            PCIAD_Port(31 downto 16) <= CFG_DeviceID;
                            PCIAD_Port(15 downto  0) <= CFG_VendorID;

                        when "000001" =>                        -- R}h/Xe[^XWX^
                            PCIAD_Port(31 downto 16) <= CFG_Status;
                            PCIAD_Port(15 downto  2) <= CFG_Command(15 downto 2);
                            PCIAD_Port(1)            <= CFG_Cmd_Mem;
                            PCIAD_Port(0)            <= CFG_Cmd_Io;

                        when "000010" =>                        -- NXR[h
                            PCIAD_Port(31 downto 24) <= CFG_BaseClass;
                            PCIAD_Port(23 downto 16) <= CFG_SubClass;
                            PCIAD_Port(15 downto  8) <= CFG_ProgramIF;
                            PCIAD_Port( 7 downto  0) <= CFG_RevisionID;

                        when "000011" =>                        -- wb_^Cvق
                            PCIAD_Port(31 downto 24) <= (others => '0');
                            PCIAD_Port(23 downto 16) <= CFG_HeaderType;
                            PCIAD_Port(15 downto  0) <= (others => '0');

                        when "000100" =>                        -- x[XAhXWX^0
                            PCIAD_Port(31 downto 24) <= CFG_Base_Addr0;
                            PCIAD_Port(23 downto  0) <= (others => '0');

                        when "000101" =>                        -- x[XAhXWX^1
                            PCIAD_Port(31 downto 16) <= (others => '0');
                            --PCIAD_Port(15 downto  2) <= CFG_Base_Addr1;                           --px0
                            PCIAD_Port(15 downto  3) <= CFG_Base_Addr1;                             --px0
                            PCIAD_Port( 1 downto  0) <= "01";

                        when "001111" =>                        -- 荞݊֘AWX^
                            PCIAD_Port(31 downto 16) <= (others => '0');
                            PCIAD_Port(15 downto  8) <= CFG_Int_Pin;
                            PCIAD_Port( 7 downto  0) <= CFG_Int_Line;

                        when others => -- ̑̃WX^
                            PCIAD_Port  <= (others => '0');     -- ׂ0Ԃ

                    end case;

                end if;

                LOCAL_DTACK         <= '1' ;                    -- [JoXV[PT f[^]tO Zbg
                LOCAL_NEXT_STATE    := LOCAL_STATE_COMP;

            -- ********** LOCAL_STATE_COMP̓ ********** --
            when LOCAL_STATE_COMP =>                            -- [JoXANZX
                MEM_CEn             <= '1';                     -- SRAM /CE fBAT[g
                ---MEM_DATA_HiZ     <= '0';                     -- [Jf[^oXo͕       --px0
                MEM_DATA_HiZ        <= '1';                     -- [Jf[^oX͕       --px0

                WAIT_Count          := (others => '0');         -- EFCgJE^ NA
                LOCAL_DTACK         <= '0';                     -- [JoXV[PT f[^]tO NA
                LOCAL_NEXT_STATE    := LOCAL_IDLE;

            -- ********************************************** --
            when others => null;    -- ȊO̒lł͉ȂꍇłK

        end case;

    end if;

end process LOCAL_BUS_Seq ;


-- ************************************************************************* --
-- **********    AhXfR[_
-- ************************************************************************* --
-- TCNorRtBO[VTCNqbg = IĂ
Hit_Device <= Hit_Memory or Hit_Config or Hit_Io;

Address_Decoder : process (
    PCI_IDSEL,          -- RtBO[VfoCXZNg
    PCI_Address,        -- PCIoXAhX
    PCI_BusCommand,     -- oXR}h
    CFG_Base_Addr0,     -- x[XAhXWX^0
    CFG_Base_Addr1,     -- x[XAhXWX^1
    CFG_Cmd_Mem,        -- RtBO[VWX^ Cl[urbg
    CFG_Cmd_Io          -- RtBO[VWX^ I/OCl[urbg
    )
begin

    -- Ԃւ̃ANZXAhXƃx[XAhX0v
    if (
            PCI_BusCommand(3 downto 1) = PCI_MemCycle       -- TCN
        ) and (
            PCI_Address(31 downto 24) = CFG_Base_Addr0      -- x[XAhX0Ɣr
        ) and (
            CFG_Cmd_Mem = '1'                               -- RtBO[V R}hWX^ Cl[urbg
        )
    then
        Hit_Memory <= '1';                                  -- TCNqbg
    else
        Hit_Memory <= '0';
    end if;

    -- I/OԂւ̃ANZXAhXƃx[XAhX1v
    if (
            PCI_BusCommand(3 downto 1) = PCI_IoCycle        -- I/OTCN
        ) and (
            CFG_Cmd_Io = '1'                                -- RtBO[V R}hWX^ I/OCl[urbg
        ) and (
            PCI_Address(31 downto 16)   = X"0000"           -- 16rbg0
        ) and (
            --PCI_Address(15 downto 2 ) = CFG_Base_Addr1(15 downto 2)                               --px0
            PCI_Address(15 downto 3 )   = CFG_Base_Addr1(15 downto 3)                               --px0
        )
    then
        Hit_Io <= '1';                                      -- I/OTCNqbg

    else
        Hit_Io <= '0';
    end if;

    -- RtBO[VԂւ̃ANZXǂF
    if (
            PCI_BusCommand(3 downto 1) = PCI_CfgCycle       -- RtBO[VTCN
        ) and (
            PCI_IDSEL = '1'                                 -- IĂ邩
        ) and (
            PCI_Address(10 downto 8)    = "000"             -- t@NVԍ0̂
        ) and (
            PCI_Address(1 downto 0)     = "00"              -- ^Cv0̂
        )
    then
        Hit_Config  <= '1';                                 -- RtBO[VTCNqbg
    else
        Hit_Config  <= '0';
    end if;

end process Address_Decoder;


-- ************************************************************************* --
-- **********    peBWFl[^
-- ************************************************************************* --

PCI_Parity_Gen : process ( PCIAD_Port, C_BE_n )
    variable temp : std_logic_vector(5 downto 0);    -- e|
begin
    -- ԃpeB --
    temp(0) := PCIAD_Port(31) xor PCIAD_Port(30) xor PCIAD_Port(29) xor PCIAD_Port(28) xor PCIAD_Port(27) xor PCIAD_Port(26);
    temp(1) := PCIAD_Port(25) xor PCIAD_Port(24) xor PCIAD_Port(23) xor PCIAD_Port(22) xor PCIAD_Port(21) xor PCIAD_Port(20);
    temp(2) := PCIAD_Port(19) xor PCIAD_Port(18) xor PCIAD_Port(17) xor PCIAD_Port(16) xor PCIAD_Port(15) xor PCIAD_Port(14);
    temp(3) := PCIAD_Port(13) xor PCIAD_Port(12) xor PCIAD_Port(11) xor PCIAD_Port(10) xor PCIAD_Port(9)  xor PCIAD_Port(8);
    temp(4) := PCIAD_Port(7)  xor PCIAD_Port(6)  xor PCIAD_Port(5)  xor PCIAD_Port(4)  xor PCIAD_Port(3)  xor PCIAD_Port(2);
    temp(5) := PCIAD_Port(1)  xor PCIAD_Port(0)  xor C_BE_n(3) xor C_BE_n(2) xor C_BE_n(1) xor C_BE_n(0);

    -- peB --
    PAR_Port <= temp(0) xor temp(1) xor temp(2) xor temp(3) xor temp(4) xor temp(5);

end process PCI_Parity_Gen ;

end RTL;
